%% Initialize matrix
% Define a homogeneous transformation with a random displacement and no
% rotation
A = [eye(3) rand(3, 1); zeros(1,3) 1];

%% Extract element in row 3, column 2
A(3, 2) % look at the value
A(3, 2) = 1 % set the value

%% extract first column
A(:, 1) % this pulls out all elements in the first column
A(4, :) % this pulls out all elements in the fourth row
A(end, :) % end is Matlab shorthand for the last row or column

%% Turn A into a column vector
% This stacks the columns of A on top of each other into a vector
A(:)

%% Extract upper left 3x3 matrix
R = A(1:3, 1:3)

% Check if it could be a rotation matrix
if det(R) ~= 1
    disp('R is not a rotation matrix')
else
    disp('R could be a rotation matrix')
end

%% Element-wise operations are not the same

R * R % this does the standard matrix multiplication, 
    % the number of columns in the first matrix must be equal to the number
    % of rows in the second
R .* R % this does element-wise multiplication
    % both matrices must be the same size

% Test if the results are equal
if isequal( R * R, R .* R) % use isequal to test equality of non-scalar values
        % use == to test equality of scalars
    disp('Results are the same')
else
    disp('Results are different')
end
